"
 File: ResultSet.st
 Desc: class for handling result sets
 Date: 06-FEB-2001
 Author: V.Krishna Kumar
"

""""""""""""""""""""""""""

"THIS CLASS IS INCOMPLETE"

""""""""""""""""""""""""""

Object subclass: #ResultSet
	instanceVariableNames: 'rowCount colCount connection hMYSQLRES row'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Database'
!


ResultSet class defineCFunc: 'mysqlStoreResult'
	withSelectorArgs: 'mysqlStoreResult: hMYSQL'
	returning: #cObject
	args: #(cObject)
!

ResultSet class defineCFunc: 'mysqlFreeResult'
	withSelectorArgs: 'mysqlFreeResult: hResult'
	returning: #void
	args: #(cObject)
!

"ResultSet class defineCFunc: 'mysqlFetchRow'
	withSelectorArgs: 'mysqlFetchRow: hResult'
	returning: (CType baseType: MYSQLROW) 
	args: #(cObject)
!
"
ResultSet class defineCFunc: 'mysqlRowCount'
	withSelectorArgs: 'mysqlRowCount: hResult'
	returning: #int
	args: #(cObject)
!

ResultSet class defineCFunc: 'mysqlFieldCount'
	withSelectorArgs: 'mysqlFieldCount: hMYSQL'
	returning: #int
	args: #(cObject)
!

ResultSet class defineCFunc: 'mysqlNumFields'
	withSelectorArgs: 'mysqlNumFields: hMYSQLRES'
	returning: #int
	args: #(cObject)
!
	

!ResultSet class methodsFor: 'instance creation'!

open: aConnection
	| obj handle|
	handle := ResultSet mysqlStoreResult: (aConnection handle).
	(handle = nil) 
		ifTrue: [ (ResultSet mysqlFieldCount: (aConnection handle) > 0)
				ifTrue: [self raiseException]
				ifFalse: [^ nil].
			]
		ifFalse: [  obj := self new.
			    obj nativeHandle: handle; init.
			    ^ obj].
! !

!ResultSet methodsFor: 'initialization'!

init
	rowCount := (ResultSet mysqlRowCount: hMYSQLRES).
	colCount := (ResultSet mysqlNumFields: hMYSQLRES).
	row := nil.
! !

!ResultSet methodsFor: 'accessors' !

nativeHandle
	^ hMYSQLRES
!
nativeHandle: aHandle
	hMYSQLRES := aHandle.
	^ self
!

rowCount
	^ rowCount
!
fieldCount
	^ colCount
! !

!ResultSet methodsFor: 'cleaning up'!

close
	rowCount := 0.
	colCount := 0.
	ResultSet mysqlFreeResult: hMYSQLRES.
	hMYSQLRES = nil
!
finalize
	(hMYSQLRES ~= nil)
		ifTrue: [self close].
! !

	


	
			

